package com.mtcarpenter.mall.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class UmsCompanyInfoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public UmsCompanyInfoExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andCompNameIsNull() {
            addCriterion("comp_name is null");
            return (Criteria) this;
        }

        public Criteria andCompNameIsNotNull() {
            addCriterion("comp_name is not null");
            return (Criteria) this;
        }

        public Criteria andCompNameEqualTo(String value) {
            addCriterion("comp_name =", value, "compName");
            return (Criteria) this;
        }

        public Criteria andCompNameNotEqualTo(String value) {
            addCriterion("comp_name <>", value, "compName");
            return (Criteria) this;
        }

        public Criteria andCompNameGreaterThan(String value) {
            addCriterion("comp_name >", value, "compName");
            return (Criteria) this;
        }

        public Criteria andCompNameGreaterThanOrEqualTo(String value) {
            addCriterion("comp_name >=", value, "compName");
            return (Criteria) this;
        }

        public Criteria andCompNameLessThan(String value) {
            addCriterion("comp_name <", value, "compName");
            return (Criteria) this;
        }

        public Criteria andCompNameLessThanOrEqualTo(String value) {
            addCriterion("comp_name <=", value, "compName");
            return (Criteria) this;
        }

        public Criteria andCompNameLike(String value) {
            addCriterion("comp_name like", value, "compName");
            return (Criteria) this;
        }

        public Criteria andCompNameNotLike(String value) {
            addCriterion("comp_name not like", value, "compName");
            return (Criteria) this;
        }

        public Criteria andCompNameIn(List<String> values) {
            addCriterion("comp_name in", values, "compName");
            return (Criteria) this;
        }

        public Criteria andCompNameNotIn(List<String> values) {
            addCriterion("comp_name not in", values, "compName");
            return (Criteria) this;
        }

        public Criteria andCompNameBetween(String value1, String value2) {
            addCriterion("comp_name between", value1, value2, "compName");
            return (Criteria) this;
        }

        public Criteria andCompNameNotBetween(String value1, String value2) {
            addCriterion("comp_name not between", value1, value2, "compName");
            return (Criteria) this;
        }

        public Criteria andCompImgsIsNull() {
            addCriterion("comp_imgs is null");
            return (Criteria) this;
        }

        public Criteria andCompImgsIsNotNull() {
            addCriterion("comp_imgs is not null");
            return (Criteria) this;
        }

        public Criteria andCompImgsEqualTo(String value) {
            addCriterion("comp_imgs =", value, "compImgs");
            return (Criteria) this;
        }

        public Criteria andCompImgsNotEqualTo(String value) {
            addCriterion("comp_imgs <>", value, "compImgs");
            return (Criteria) this;
        }

        public Criteria andCompImgsGreaterThan(String value) {
            addCriterion("comp_imgs >", value, "compImgs");
            return (Criteria) this;
        }

        public Criteria andCompImgsGreaterThanOrEqualTo(String value) {
            addCriterion("comp_imgs >=", value, "compImgs");
            return (Criteria) this;
        }

        public Criteria andCompImgsLessThan(String value) {
            addCriterion("comp_imgs <", value, "compImgs");
            return (Criteria) this;
        }

        public Criteria andCompImgsLessThanOrEqualTo(String value) {
            addCriterion("comp_imgs <=", value, "compImgs");
            return (Criteria) this;
        }

        public Criteria andCompImgsLike(String value) {
            addCriterion("comp_imgs like", value, "compImgs");
            return (Criteria) this;
        }

        public Criteria andCompImgsNotLike(String value) {
            addCriterion("comp_imgs not like", value, "compImgs");
            return (Criteria) this;
        }

        public Criteria andCompImgsIn(List<String> values) {
            addCriterion("comp_imgs in", values, "compImgs");
            return (Criteria) this;
        }

        public Criteria andCompImgsNotIn(List<String> values) {
            addCriterion("comp_imgs not in", values, "compImgs");
            return (Criteria) this;
        }

        public Criteria andCompImgsBetween(String value1, String value2) {
            addCriterion("comp_imgs between", value1, value2, "compImgs");
            return (Criteria) this;
        }

        public Criteria andCompImgsNotBetween(String value1, String value2) {
            addCriterion("comp_imgs not between", value1, value2, "compImgs");
            return (Criteria) this;
        }

        public Criteria andCompUrlIsNull() {
            addCriterion("comp_url is null");
            return (Criteria) this;
        }

        public Criteria andCompUrlIsNotNull() {
            addCriterion("comp_url is not null");
            return (Criteria) this;
        }

        public Criteria andCompUrlEqualTo(String value) {
            addCriterion("comp_url =", value, "compUrl");
            return (Criteria) this;
        }

        public Criteria andCompUrlNotEqualTo(String value) {
            addCriterion("comp_url <>", value, "compUrl");
            return (Criteria) this;
        }

        public Criteria andCompUrlGreaterThan(String value) {
            addCriterion("comp_url >", value, "compUrl");
            return (Criteria) this;
        }

        public Criteria andCompUrlGreaterThanOrEqualTo(String value) {
            addCriterion("comp_url >=", value, "compUrl");
            return (Criteria) this;
        }

        public Criteria andCompUrlLessThan(String value) {
            addCriterion("comp_url <", value, "compUrl");
            return (Criteria) this;
        }

        public Criteria andCompUrlLessThanOrEqualTo(String value) {
            addCriterion("comp_url <=", value, "compUrl");
            return (Criteria) this;
        }

        public Criteria andCompUrlLike(String value) {
            addCriterion("comp_url like", value, "compUrl");
            return (Criteria) this;
        }

        public Criteria andCompUrlNotLike(String value) {
            addCriterion("comp_url not like", value, "compUrl");
            return (Criteria) this;
        }

        public Criteria andCompUrlIn(List<String> values) {
            addCriterion("comp_url in", values, "compUrl");
            return (Criteria) this;
        }

        public Criteria andCompUrlNotIn(List<String> values) {
            addCriterion("comp_url not in", values, "compUrl");
            return (Criteria) this;
        }

        public Criteria andCompUrlBetween(String value1, String value2) {
            addCriterion("comp_url between", value1, value2, "compUrl");
            return (Criteria) this;
        }

        public Criteria andCompUrlNotBetween(String value1, String value2) {
            addCriterion("comp_url not between", value1, value2, "compUrl");
            return (Criteria) this;
        }

        public Criteria andCompProdLicenseNumIsNull() {
            addCriterion("comp_prod_license_num is null");
            return (Criteria) this;
        }

        public Criteria andCompProdLicenseNumIsNotNull() {
            addCriterion("comp_prod_license_num is not null");
            return (Criteria) this;
        }

        public Criteria andCompProdLicenseNumEqualTo(String value) {
            addCriterion("comp_prod_license_num =", value, "compProdLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompProdLicenseNumNotEqualTo(String value) {
            addCriterion("comp_prod_license_num <>", value, "compProdLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompProdLicenseNumGreaterThan(String value) {
            addCriterion("comp_prod_license_num >", value, "compProdLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompProdLicenseNumGreaterThanOrEqualTo(String value) {
            addCriterion("comp_prod_license_num >=", value, "compProdLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompProdLicenseNumLessThan(String value) {
            addCriterion("comp_prod_license_num <", value, "compProdLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompProdLicenseNumLessThanOrEqualTo(String value) {
            addCriterion("comp_prod_license_num <=", value, "compProdLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompProdLicenseNumLike(String value) {
            addCriterion("comp_prod_license_num like", value, "compProdLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompProdLicenseNumNotLike(String value) {
            addCriterion("comp_prod_license_num not like", value, "compProdLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompProdLicenseNumIn(List<String> values) {
            addCriterion("comp_prod_license_num in", values, "compProdLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompProdLicenseNumNotIn(List<String> values) {
            addCriterion("comp_prod_license_num not in", values, "compProdLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompProdLicenseNumBetween(String value1, String value2) {
            addCriterion("comp_prod_license_num between", value1, value2, "compProdLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompProdLicenseNumNotBetween(String value1, String value2) {
            addCriterion("comp_prod_license_num not between", value1, value2, "compProdLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompManageLicenseNumIsNull() {
            addCriterion("comp_manage_license_num is null");
            return (Criteria) this;
        }

        public Criteria andCompManageLicenseNumIsNotNull() {
            addCriterion("comp_manage_license_num is not null");
            return (Criteria) this;
        }

        public Criteria andCompManageLicenseNumEqualTo(String value) {
            addCriterion("comp_manage_license_num =", value, "compManageLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompManageLicenseNumNotEqualTo(String value) {
            addCriterion("comp_manage_license_num <>", value, "compManageLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompManageLicenseNumGreaterThan(String value) {
            addCriterion("comp_manage_license_num >", value, "compManageLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompManageLicenseNumGreaterThanOrEqualTo(String value) {
            addCriterion("comp_manage_license_num >=", value, "compManageLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompManageLicenseNumLessThan(String value) {
            addCriterion("comp_manage_license_num <", value, "compManageLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompManageLicenseNumLessThanOrEqualTo(String value) {
            addCriterion("comp_manage_license_num <=", value, "compManageLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompManageLicenseNumLike(String value) {
            addCriterion("comp_manage_license_num like", value, "compManageLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompManageLicenseNumNotLike(String value) {
            addCriterion("comp_manage_license_num not like", value, "compManageLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompManageLicenseNumIn(List<String> values) {
            addCriterion("comp_manage_license_num in", values, "compManageLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompManageLicenseNumNotIn(List<String> values) {
            addCriterion("comp_manage_license_num not in", values, "compManageLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompManageLicenseNumBetween(String value1, String value2) {
            addCriterion("comp_manage_license_num between", value1, value2, "compManageLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompManageLicenseNumNotBetween(String value1, String value2) {
            addCriterion("comp_manage_license_num not between", value1, value2, "compManageLicenseNum");
            return (Criteria) this;
        }

        public Criteria andCompSocialCodeIsNull() {
            addCriterion("comp_social_code is null");
            return (Criteria) this;
        }

        public Criteria andCompSocialCodeIsNotNull() {
            addCriterion("comp_social_code is not null");
            return (Criteria) this;
        }

        public Criteria andCompSocialCodeEqualTo(String value) {
            addCriterion("comp_social_code =", value, "compSocialCode");
            return (Criteria) this;
        }

        public Criteria andCompSocialCodeNotEqualTo(String value) {
            addCriterion("comp_social_code <>", value, "compSocialCode");
            return (Criteria) this;
        }

        public Criteria andCompSocialCodeGreaterThan(String value) {
            addCriterion("comp_social_code >", value, "compSocialCode");
            return (Criteria) this;
        }

        public Criteria andCompSocialCodeGreaterThanOrEqualTo(String value) {
            addCriterion("comp_social_code >=", value, "compSocialCode");
            return (Criteria) this;
        }

        public Criteria andCompSocialCodeLessThan(String value) {
            addCriterion("comp_social_code <", value, "compSocialCode");
            return (Criteria) this;
        }

        public Criteria andCompSocialCodeLessThanOrEqualTo(String value) {
            addCriterion("comp_social_code <=", value, "compSocialCode");
            return (Criteria) this;
        }

        public Criteria andCompSocialCodeLike(String value) {
            addCriterion("comp_social_code like", value, "compSocialCode");
            return (Criteria) this;
        }

        public Criteria andCompSocialCodeNotLike(String value) {
            addCriterion("comp_social_code not like", value, "compSocialCode");
            return (Criteria) this;
        }

        public Criteria andCompSocialCodeIn(List<String> values) {
            addCriterion("comp_social_code in", values, "compSocialCode");
            return (Criteria) this;
        }

        public Criteria andCompSocialCodeNotIn(List<String> values) {
            addCriterion("comp_social_code not in", values, "compSocialCode");
            return (Criteria) this;
        }

        public Criteria andCompSocialCodeBetween(String value1, String value2) {
            addCriterion("comp_social_code between", value1, value2, "compSocialCode");
            return (Criteria) this;
        }

        public Criteria andCompSocialCodeNotBetween(String value1, String value2) {
            addCriterion("comp_social_code not between", value1, value2, "compSocialCode");
            return (Criteria) this;
        }

        public Criteria andCompConPersonIsNull() {
            addCriterion("comp_con_person is null");
            return (Criteria) this;
        }

        public Criteria andCompConPersonIsNotNull() {
            addCriterion("comp_con_person is not null");
            return (Criteria) this;
        }

        public Criteria andCompConPersonEqualTo(String value) {
            addCriterion("comp_con_person =", value, "compConPerson");
            return (Criteria) this;
        }

        public Criteria andCompConPersonNotEqualTo(String value) {
            addCriterion("comp_con_person <>", value, "compConPerson");
            return (Criteria) this;
        }

        public Criteria andCompConPersonGreaterThan(String value) {
            addCriterion("comp_con_person >", value, "compConPerson");
            return (Criteria) this;
        }

        public Criteria andCompConPersonGreaterThanOrEqualTo(String value) {
            addCriterion("comp_con_person >=", value, "compConPerson");
            return (Criteria) this;
        }

        public Criteria andCompConPersonLessThan(String value) {
            addCriterion("comp_con_person <", value, "compConPerson");
            return (Criteria) this;
        }

        public Criteria andCompConPersonLessThanOrEqualTo(String value) {
            addCriterion("comp_con_person <=", value, "compConPerson");
            return (Criteria) this;
        }

        public Criteria andCompConPersonLike(String value) {
            addCriterion("comp_con_person like", value, "compConPerson");
            return (Criteria) this;
        }

        public Criteria andCompConPersonNotLike(String value) {
            addCriterion("comp_con_person not like", value, "compConPerson");
            return (Criteria) this;
        }

        public Criteria andCompConPersonIn(List<String> values) {
            addCriterion("comp_con_person in", values, "compConPerson");
            return (Criteria) this;
        }

        public Criteria andCompConPersonNotIn(List<String> values) {
            addCriterion("comp_con_person not in", values, "compConPerson");
            return (Criteria) this;
        }

        public Criteria andCompConPersonBetween(String value1, String value2) {
            addCriterion("comp_con_person between", value1, value2, "compConPerson");
            return (Criteria) this;
        }

        public Criteria andCompConPersonNotBetween(String value1, String value2) {
            addCriterion("comp_con_person not between", value1, value2, "compConPerson");
            return (Criteria) this;
        }

        public Criteria andCompConTypeIsNull() {
            addCriterion("comp_con_type is null");
            return (Criteria) this;
        }

        public Criteria andCompConTypeIsNotNull() {
            addCriterion("comp_con_type is not null");
            return (Criteria) this;
        }

        public Criteria andCompConTypeEqualTo(String value) {
            addCriterion("comp_con_type =", value, "compConType");
            return (Criteria) this;
        }

        public Criteria andCompConTypeNotEqualTo(String value) {
            addCriterion("comp_con_type <>", value, "compConType");
            return (Criteria) this;
        }

        public Criteria andCompConTypeGreaterThan(String value) {
            addCriterion("comp_con_type >", value, "compConType");
            return (Criteria) this;
        }

        public Criteria andCompConTypeGreaterThanOrEqualTo(String value) {
            addCriterion("comp_con_type >=", value, "compConType");
            return (Criteria) this;
        }

        public Criteria andCompConTypeLessThan(String value) {
            addCriterion("comp_con_type <", value, "compConType");
            return (Criteria) this;
        }

        public Criteria andCompConTypeLessThanOrEqualTo(String value) {
            addCriterion("comp_con_type <=", value, "compConType");
            return (Criteria) this;
        }

        public Criteria andCompConTypeLike(String value) {
            addCriterion("comp_con_type like", value, "compConType");
            return (Criteria) this;
        }

        public Criteria andCompConTypeNotLike(String value) {
            addCriterion("comp_con_type not like", value, "compConType");
            return (Criteria) this;
        }

        public Criteria andCompConTypeIn(List<String> values) {
            addCriterion("comp_con_type in", values, "compConType");
            return (Criteria) this;
        }

        public Criteria andCompConTypeNotIn(List<String> values) {
            addCriterion("comp_con_type not in", values, "compConType");
            return (Criteria) this;
        }

        public Criteria andCompConTypeBetween(String value1, String value2) {
            addCriterion("comp_con_type between", value1, value2, "compConType");
            return (Criteria) this;
        }

        public Criteria andCompConTypeNotBetween(String value1, String value2) {
            addCriterion("comp_con_type not between", value1, value2, "compConType");
            return (Criteria) this;
        }

        public Criteria andCompConNumIsNull() {
            addCriterion("comp_con_num is null");
            return (Criteria) this;
        }

        public Criteria andCompConNumIsNotNull() {
            addCriterion("comp_con_num is not null");
            return (Criteria) this;
        }

        public Criteria andCompConNumEqualTo(String value) {
            addCriterion("comp_con_num =", value, "compConNum");
            return (Criteria) this;
        }

        public Criteria andCompConNumNotEqualTo(String value) {
            addCriterion("comp_con_num <>", value, "compConNum");
            return (Criteria) this;
        }

        public Criteria andCompConNumGreaterThan(String value) {
            addCriterion("comp_con_num >", value, "compConNum");
            return (Criteria) this;
        }

        public Criteria andCompConNumGreaterThanOrEqualTo(String value) {
            addCriterion("comp_con_num >=", value, "compConNum");
            return (Criteria) this;
        }

        public Criteria andCompConNumLessThan(String value) {
            addCriterion("comp_con_num <", value, "compConNum");
            return (Criteria) this;
        }

        public Criteria andCompConNumLessThanOrEqualTo(String value) {
            addCriterion("comp_con_num <=", value, "compConNum");
            return (Criteria) this;
        }

        public Criteria andCompConNumLike(String value) {
            addCriterion("comp_con_num like", value, "compConNum");
            return (Criteria) this;
        }

        public Criteria andCompConNumNotLike(String value) {
            addCriterion("comp_con_num not like", value, "compConNum");
            return (Criteria) this;
        }

        public Criteria andCompConNumIn(List<String> values) {
            addCriterion("comp_con_num in", values, "compConNum");
            return (Criteria) this;
        }

        public Criteria andCompConNumNotIn(List<String> values) {
            addCriterion("comp_con_num not in", values, "compConNum");
            return (Criteria) this;
        }

        public Criteria andCompConNumBetween(String value1, String value2) {
            addCriterion("comp_con_num between", value1, value2, "compConNum");
            return (Criteria) this;
        }

        public Criteria andCompConNumNotBetween(String value1, String value2) {
            addCriterion("comp_con_num not between", value1, value2, "compConNum");
            return (Criteria) this;
        }

        public Criteria andCompQqIsNull() {
            addCriterion("comp_qq is null");
            return (Criteria) this;
        }

        public Criteria andCompQqIsNotNull() {
            addCriterion("comp_qq is not null");
            return (Criteria) this;
        }

        public Criteria andCompQqEqualTo(String value) {
            addCriterion("comp_qq =", value, "compQq");
            return (Criteria) this;
        }

        public Criteria andCompQqNotEqualTo(String value) {
            addCriterion("comp_qq <>", value, "compQq");
            return (Criteria) this;
        }

        public Criteria andCompQqGreaterThan(String value) {
            addCriterion("comp_qq >", value, "compQq");
            return (Criteria) this;
        }

        public Criteria andCompQqGreaterThanOrEqualTo(String value) {
            addCriterion("comp_qq >=", value, "compQq");
            return (Criteria) this;
        }

        public Criteria andCompQqLessThan(String value) {
            addCriterion("comp_qq <", value, "compQq");
            return (Criteria) this;
        }

        public Criteria andCompQqLessThanOrEqualTo(String value) {
            addCriterion("comp_qq <=", value, "compQq");
            return (Criteria) this;
        }

        public Criteria andCompQqLike(String value) {
            addCriterion("comp_qq like", value, "compQq");
            return (Criteria) this;
        }

        public Criteria andCompQqNotLike(String value) {
            addCriterion("comp_qq not like", value, "compQq");
            return (Criteria) this;
        }

        public Criteria andCompQqIn(List<String> values) {
            addCriterion("comp_qq in", values, "compQq");
            return (Criteria) this;
        }

        public Criteria andCompQqNotIn(List<String> values) {
            addCriterion("comp_qq not in", values, "compQq");
            return (Criteria) this;
        }

        public Criteria andCompQqBetween(String value1, String value2) {
            addCriterion("comp_qq between", value1, value2, "compQq");
            return (Criteria) this;
        }

        public Criteria andCompQqNotBetween(String value1, String value2) {
            addCriterion("comp_qq not between", value1, value2, "compQq");
            return (Criteria) this;
        }

        public Criteria andCompManageProductIsNull() {
            addCriterion("comp_manage_product is null");
            return (Criteria) this;
        }

        public Criteria andCompManageProductIsNotNull() {
            addCriterion("comp_manage_product is not null");
            return (Criteria) this;
        }

        public Criteria andCompManageProductEqualTo(String value) {
            addCriterion("comp_manage_product =", value, "compManageProduct");
            return (Criteria) this;
        }

        public Criteria andCompManageProductNotEqualTo(String value) {
            addCriterion("comp_manage_product <>", value, "compManageProduct");
            return (Criteria) this;
        }

        public Criteria andCompManageProductGreaterThan(String value) {
            addCriterion("comp_manage_product >", value, "compManageProduct");
            return (Criteria) this;
        }

        public Criteria andCompManageProductGreaterThanOrEqualTo(String value) {
            addCriterion("comp_manage_product >=", value, "compManageProduct");
            return (Criteria) this;
        }

        public Criteria andCompManageProductLessThan(String value) {
            addCriterion("comp_manage_product <", value, "compManageProduct");
            return (Criteria) this;
        }

        public Criteria andCompManageProductLessThanOrEqualTo(String value) {
            addCriterion("comp_manage_product <=", value, "compManageProduct");
            return (Criteria) this;
        }

        public Criteria andCompManageProductLike(String value) {
            addCriterion("comp_manage_product like", value, "compManageProduct");
            return (Criteria) this;
        }

        public Criteria andCompManageProductNotLike(String value) {
            addCriterion("comp_manage_product not like", value, "compManageProduct");
            return (Criteria) this;
        }

        public Criteria andCompManageProductIn(List<String> values) {
            addCriterion("comp_manage_product in", values, "compManageProduct");
            return (Criteria) this;
        }

        public Criteria andCompManageProductNotIn(List<String> values) {
            addCriterion("comp_manage_product not in", values, "compManageProduct");
            return (Criteria) this;
        }

        public Criteria andCompManageProductBetween(String value1, String value2) {
            addCriterion("comp_manage_product between", value1, value2, "compManageProduct");
            return (Criteria) this;
        }

        public Criteria andCompManageProductNotBetween(String value1, String value2) {
            addCriterion("comp_manage_product not between", value1, value2, "compManageProduct");
            return (Criteria) this;
        }

        public Criteria andProvinceIdIsNull() {
            addCriterion("province_id is null");
            return (Criteria) this;
        }

        public Criteria andProvinceIdIsNotNull() {
            addCriterion("province_id is not null");
            return (Criteria) this;
        }

        public Criteria andProvinceIdEqualTo(String value) {
            addCriterion("province_id =", value, "provinceId");
            return (Criteria) this;
        }

        public Criteria andProvinceIdNotEqualTo(String value) {
            addCriterion("province_id <>", value, "provinceId");
            return (Criteria) this;
        }

        public Criteria andProvinceIdGreaterThan(String value) {
            addCriterion("province_id >", value, "provinceId");
            return (Criteria) this;
        }

        public Criteria andProvinceIdGreaterThanOrEqualTo(String value) {
            addCriterion("province_id >=", value, "provinceId");
            return (Criteria) this;
        }

        public Criteria andProvinceIdLessThan(String value) {
            addCriterion("province_id <", value, "provinceId");
            return (Criteria) this;
        }

        public Criteria andProvinceIdLessThanOrEqualTo(String value) {
            addCriterion("province_id <=", value, "provinceId");
            return (Criteria) this;
        }

        public Criteria andProvinceIdLike(String value) {
            addCriterion("province_id like", value, "provinceId");
            return (Criteria) this;
        }

        public Criteria andProvinceIdNotLike(String value) {
            addCriterion("province_id not like", value, "provinceId");
            return (Criteria) this;
        }

        public Criteria andProvinceIdIn(List<String> values) {
            addCriterion("province_id in", values, "provinceId");
            return (Criteria) this;
        }

        public Criteria andProvinceIdNotIn(List<String> values) {
            addCriterion("province_id not in", values, "provinceId");
            return (Criteria) this;
        }

        public Criteria andProvinceIdBetween(String value1, String value2) {
            addCriterion("province_id between", value1, value2, "provinceId");
            return (Criteria) this;
        }

        public Criteria andProvinceIdNotBetween(String value1, String value2) {
            addCriterion("province_id not between", value1, value2, "provinceId");
            return (Criteria) this;
        }

        public Criteria andCityIdIsNull() {
            addCriterion("city_id is null");
            return (Criteria) this;
        }

        public Criteria andCityIdIsNotNull() {
            addCriterion("city_id is not null");
            return (Criteria) this;
        }

        public Criteria andCityIdEqualTo(String value) {
            addCriterion("city_id =", value, "cityId");
            return (Criteria) this;
        }

        public Criteria andCityIdNotEqualTo(String value) {
            addCriterion("city_id <>", value, "cityId");
            return (Criteria) this;
        }

        public Criteria andCityIdGreaterThan(String value) {
            addCriterion("city_id >", value, "cityId");
            return (Criteria) this;
        }

        public Criteria andCityIdGreaterThanOrEqualTo(String value) {
            addCriterion("city_id >=", value, "cityId");
            return (Criteria) this;
        }

        public Criteria andCityIdLessThan(String value) {
            addCriterion("city_id <", value, "cityId");
            return (Criteria) this;
        }

        public Criteria andCityIdLessThanOrEqualTo(String value) {
            addCriterion("city_id <=", value, "cityId");
            return (Criteria) this;
        }

        public Criteria andCityIdLike(String value) {
            addCriterion("city_id like", value, "cityId");
            return (Criteria) this;
        }

        public Criteria andCityIdNotLike(String value) {
            addCriterion("city_id not like", value, "cityId");
            return (Criteria) this;
        }

        public Criteria andCityIdIn(List<String> values) {
            addCriterion("city_id in", values, "cityId");
            return (Criteria) this;
        }

        public Criteria andCityIdNotIn(List<String> values) {
            addCriterion("city_id not in", values, "cityId");
            return (Criteria) this;
        }

        public Criteria andCityIdBetween(String value1, String value2) {
            addCriterion("city_id between", value1, value2, "cityId");
            return (Criteria) this;
        }

        public Criteria andCityIdNotBetween(String value1, String value2) {
            addCriterion("city_id not between", value1, value2, "cityId");
            return (Criteria) this;
        }

        public Criteria andCountyIdIsNull() {
            addCriterion("county_id is null");
            return (Criteria) this;
        }

        public Criteria andCountyIdIsNotNull() {
            addCriterion("county_id is not null");
            return (Criteria) this;
        }

        public Criteria andCountyIdEqualTo(String value) {
            addCriterion("county_id =", value, "countyId");
            return (Criteria) this;
        }

        public Criteria andCountyIdNotEqualTo(String value) {
            addCriterion("county_id <>", value, "countyId");
            return (Criteria) this;
        }

        public Criteria andCountyIdGreaterThan(String value) {
            addCriterion("county_id >", value, "countyId");
            return (Criteria) this;
        }

        public Criteria andCountyIdGreaterThanOrEqualTo(String value) {
            addCriterion("county_id >=", value, "countyId");
            return (Criteria) this;
        }

        public Criteria andCountyIdLessThan(String value) {
            addCriterion("county_id <", value, "countyId");
            return (Criteria) this;
        }

        public Criteria andCountyIdLessThanOrEqualTo(String value) {
            addCriterion("county_id <=", value, "countyId");
            return (Criteria) this;
        }

        public Criteria andCountyIdLike(String value) {
            addCriterion("county_id like", value, "countyId");
            return (Criteria) this;
        }

        public Criteria andCountyIdNotLike(String value) {
            addCriterion("county_id not like", value, "countyId");
            return (Criteria) this;
        }

        public Criteria andCountyIdIn(List<String> values) {
            addCriterion("county_id in", values, "countyId");
            return (Criteria) this;
        }

        public Criteria andCountyIdNotIn(List<String> values) {
            addCriterion("county_id not in", values, "countyId");
            return (Criteria) this;
        }

        public Criteria andCountyIdBetween(String value1, String value2) {
            addCriterion("county_id between", value1, value2, "countyId");
            return (Criteria) this;
        }

        public Criteria andCountyIdNotBetween(String value1, String value2) {
            addCriterion("county_id not between", value1, value2, "countyId");
            return (Criteria) this;
        }

        public Criteria andTownIdIsNull() {
            addCriterion("town_id is null");
            return (Criteria) this;
        }

        public Criteria andTownIdIsNotNull() {
            addCriterion("town_id is not null");
            return (Criteria) this;
        }

        public Criteria andTownIdEqualTo(String value) {
            addCriterion("town_id =", value, "townId");
            return (Criteria) this;
        }

        public Criteria andTownIdNotEqualTo(String value) {
            addCriterion("town_id <>", value, "townId");
            return (Criteria) this;
        }

        public Criteria andTownIdGreaterThan(String value) {
            addCriterion("town_id >", value, "townId");
            return (Criteria) this;
        }

        public Criteria andTownIdGreaterThanOrEqualTo(String value) {
            addCriterion("town_id >=", value, "townId");
            return (Criteria) this;
        }

        public Criteria andTownIdLessThan(String value) {
            addCriterion("town_id <", value, "townId");
            return (Criteria) this;
        }

        public Criteria andTownIdLessThanOrEqualTo(String value) {
            addCriterion("town_id <=", value, "townId");
            return (Criteria) this;
        }

        public Criteria andTownIdLike(String value) {
            addCriterion("town_id like", value, "townId");
            return (Criteria) this;
        }

        public Criteria andTownIdNotLike(String value) {
            addCriterion("town_id not like", value, "townId");
            return (Criteria) this;
        }

        public Criteria andTownIdIn(List<String> values) {
            addCriterion("town_id in", values, "townId");
            return (Criteria) this;
        }

        public Criteria andTownIdNotIn(List<String> values) {
            addCriterion("town_id not in", values, "townId");
            return (Criteria) this;
        }

        public Criteria andTownIdBetween(String value1, String value2) {
            addCriterion("town_id between", value1, value2, "townId");
            return (Criteria) this;
        }

        public Criteria andTownIdNotBetween(String value1, String value2) {
            addCriterion("town_id not between", value1, value2, "townId");
            return (Criteria) this;
        }

        public Criteria andVillageIdIsNull() {
            addCriterion("village_id is null");
            return (Criteria) this;
        }

        public Criteria andVillageIdIsNotNull() {
            addCriterion("village_id is not null");
            return (Criteria) this;
        }

        public Criteria andVillageIdEqualTo(String value) {
            addCriterion("village_id =", value, "villageId");
            return (Criteria) this;
        }

        public Criteria andVillageIdNotEqualTo(String value) {
            addCriterion("village_id <>", value, "villageId");
            return (Criteria) this;
        }

        public Criteria andVillageIdGreaterThan(String value) {
            addCriterion("village_id >", value, "villageId");
            return (Criteria) this;
        }

        public Criteria andVillageIdGreaterThanOrEqualTo(String value) {
            addCriterion("village_id >=", value, "villageId");
            return (Criteria) this;
        }

        public Criteria andVillageIdLessThan(String value) {
            addCriterion("village_id <", value, "villageId");
            return (Criteria) this;
        }

        public Criteria andVillageIdLessThanOrEqualTo(String value) {
            addCriterion("village_id <=", value, "villageId");
            return (Criteria) this;
        }

        public Criteria andVillageIdLike(String value) {
            addCriterion("village_id like", value, "villageId");
            return (Criteria) this;
        }

        public Criteria andVillageIdNotLike(String value) {
            addCriterion("village_id not like", value, "villageId");
            return (Criteria) this;
        }

        public Criteria andVillageIdIn(List<String> values) {
            addCriterion("village_id in", values, "villageId");
            return (Criteria) this;
        }

        public Criteria andVillageIdNotIn(List<String> values) {
            addCriterion("village_id not in", values, "villageId");
            return (Criteria) this;
        }

        public Criteria andVillageIdBetween(String value1, String value2) {
            addCriterion("village_id between", value1, value2, "villageId");
            return (Criteria) this;
        }

        public Criteria andVillageIdNotBetween(String value1, String value2) {
            addCriterion("village_id not between", value1, value2, "villageId");
            return (Criteria) this;
        }

        public Criteria andDetailAddressIsNull() {
            addCriterion("detail_address is null");
            return (Criteria) this;
        }

        public Criteria andDetailAddressIsNotNull() {
            addCriterion("detail_address is not null");
            return (Criteria) this;
        }

        public Criteria andDetailAddressEqualTo(String value) {
            addCriterion("detail_address =", value, "detailAddress");
            return (Criteria) this;
        }

        public Criteria andDetailAddressNotEqualTo(String value) {
            addCriterion("detail_address <>", value, "detailAddress");
            return (Criteria) this;
        }

        public Criteria andDetailAddressGreaterThan(String value) {
            addCriterion("detail_address >", value, "detailAddress");
            return (Criteria) this;
        }

        public Criteria andDetailAddressGreaterThanOrEqualTo(String value) {
            addCriterion("detail_address >=", value, "detailAddress");
            return (Criteria) this;
        }

        public Criteria andDetailAddressLessThan(String value) {
            addCriterion("detail_address <", value, "detailAddress");
            return (Criteria) this;
        }

        public Criteria andDetailAddressLessThanOrEqualTo(String value) {
            addCriterion("detail_address <=", value, "detailAddress");
            return (Criteria) this;
        }

        public Criteria andDetailAddressLike(String value) {
            addCriterion("detail_address like", value, "detailAddress");
            return (Criteria) this;
        }

        public Criteria andDetailAddressNotLike(String value) {
            addCriterion("detail_address not like", value, "detailAddress");
            return (Criteria) this;
        }

        public Criteria andDetailAddressIn(List<String> values) {
            addCriterion("detail_address in", values, "detailAddress");
            return (Criteria) this;
        }

        public Criteria andDetailAddressNotIn(List<String> values) {
            addCriterion("detail_address not in", values, "detailAddress");
            return (Criteria) this;
        }

        public Criteria andDetailAddressBetween(String value1, String value2) {
            addCriterion("detail_address between", value1, value2, "detailAddress");
            return (Criteria) this;
        }

        public Criteria andDetailAddressNotBetween(String value1, String value2) {
            addCriterion("detail_address not between", value1, value2, "detailAddress");
            return (Criteria) this;
        }

        public Criteria andLongitudeIsNull() {
            addCriterion("longitude is null");
            return (Criteria) this;
        }

        public Criteria andLongitudeIsNotNull() {
            addCriterion("longitude is not null");
            return (Criteria) this;
        }

        public Criteria andLongitudeEqualTo(String value) {
            addCriterion("longitude =", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeNotEqualTo(String value) {
            addCriterion("longitude <>", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeGreaterThan(String value) {
            addCriterion("longitude >", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeGreaterThanOrEqualTo(String value) {
            addCriterion("longitude >=", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeLessThan(String value) {
            addCriterion("longitude <", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeLessThanOrEqualTo(String value) {
            addCriterion("longitude <=", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeLike(String value) {
            addCriterion("longitude like", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeNotLike(String value) {
            addCriterion("longitude not like", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeIn(List<String> values) {
            addCriterion("longitude in", values, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeNotIn(List<String> values) {
            addCriterion("longitude not in", values, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeBetween(String value1, String value2) {
            addCriterion("longitude between", value1, value2, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeNotBetween(String value1, String value2) {
            addCriterion("longitude not between", value1, value2, "longitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeIsNull() {
            addCriterion("latitude is null");
            return (Criteria) this;
        }

        public Criteria andLatitudeIsNotNull() {
            addCriterion("latitude is not null");
            return (Criteria) this;
        }

        public Criteria andLatitudeEqualTo(String value) {
            addCriterion("latitude =", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeNotEqualTo(String value) {
            addCriterion("latitude <>", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeGreaterThan(String value) {
            addCriterion("latitude >", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeGreaterThanOrEqualTo(String value) {
            addCriterion("latitude >=", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeLessThan(String value) {
            addCriterion("latitude <", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeLessThanOrEqualTo(String value) {
            addCriterion("latitude <=", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeLike(String value) {
            addCriterion("latitude like", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeNotLike(String value) {
            addCriterion("latitude not like", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeIn(List<String> values) {
            addCriterion("latitude in", values, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeNotIn(List<String> values) {
            addCriterion("latitude not in", values, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeBetween(String value1, String value2) {
            addCriterion("latitude between", value1, value2, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeNotBetween(String value1, String value2) {
            addCriterion("latitude not between", value1, value2, "latitude");
            return (Criteria) this;
        }

        public Criteria andCompStatusIsNull() {
            addCriterion("comp_status is null");
            return (Criteria) this;
        }

        public Criteria andCompStatusIsNotNull() {
            addCriterion("comp_status is not null");
            return (Criteria) this;
        }

        public Criteria andCompStatusEqualTo(Integer value) {
            addCriterion("comp_status =", value, "compStatus");
            return (Criteria) this;
        }

        public Criteria andCompStatusNotEqualTo(Integer value) {
            addCriterion("comp_status <>", value, "compStatus");
            return (Criteria) this;
        }

        public Criteria andCompStatusGreaterThan(Integer value) {
            addCriterion("comp_status >", value, "compStatus");
            return (Criteria) this;
        }

        public Criteria andCompStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("comp_status >=", value, "compStatus");
            return (Criteria) this;
        }

        public Criteria andCompStatusLessThan(Integer value) {
            addCriterion("comp_status <", value, "compStatus");
            return (Criteria) this;
        }

        public Criteria andCompStatusLessThanOrEqualTo(Integer value) {
            addCriterion("comp_status <=", value, "compStatus");
            return (Criteria) this;
        }

        public Criteria andCompStatusIn(List<Integer> values) {
            addCriterion("comp_status in", values, "compStatus");
            return (Criteria) this;
        }

        public Criteria andCompStatusNotIn(List<Integer> values) {
            addCriterion("comp_status not in", values, "compStatus");
            return (Criteria) this;
        }

        public Criteria andCompStatusBetween(Integer value1, Integer value2) {
            addCriterion("comp_status between", value1, value2, "compStatus");
            return (Criteria) this;
        }

        public Criteria andCompStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("comp_status not between", value1, value2, "compStatus");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateIdIsNull() {
            addCriterion("create_id is null");
            return (Criteria) this;
        }

        public Criteria andCreateIdIsNotNull() {
            addCriterion("create_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreateIdEqualTo(Integer value) {
            addCriterion("create_id =", value, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdNotEqualTo(Integer value) {
            addCriterion("create_id <>", value, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdGreaterThan(Integer value) {
            addCriterion("create_id >", value, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("create_id >=", value, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdLessThan(Integer value) {
            addCriterion("create_id <", value, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdLessThanOrEqualTo(Integer value) {
            addCriterion("create_id <=", value, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdIn(List<Integer> values) {
            addCriterion("create_id in", values, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdNotIn(List<Integer> values) {
            addCriterion("create_id not in", values, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdBetween(Integer value1, Integer value2) {
            addCriterion("create_id between", value1, value2, "createId");
            return (Criteria) this;
        }

        public Criteria andCreateIdNotBetween(Integer value1, Integer value2) {
            addCriterion("create_id not between", value1, value2, "createId");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateIdIsNull() {
            addCriterion("update_id is null");
            return (Criteria) this;
        }

        public Criteria andUpdateIdIsNotNull() {
            addCriterion("update_id is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateIdEqualTo(Integer value) {
            addCriterion("update_id =", value, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdNotEqualTo(Integer value) {
            addCriterion("update_id <>", value, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdGreaterThan(Integer value) {
            addCriterion("update_id >", value, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("update_id >=", value, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdLessThan(Integer value) {
            addCriterion("update_id <", value, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdLessThanOrEqualTo(Integer value) {
            addCriterion("update_id <=", value, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdIn(List<Integer> values) {
            addCriterion("update_id in", values, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdNotIn(List<Integer> values) {
            addCriterion("update_id not in", values, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdBetween(Integer value1, Integer value2) {
            addCriterion("update_id between", value1, value2, "updateId");
            return (Criteria) this;
        }

        public Criteria andUpdateIdNotBetween(Integer value1, Integer value2) {
            addCriterion("update_id not between", value1, value2, "updateId");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}